
// ⺻ 
#define	__STDIO_FDEVOPEN_COMPAT_12


#include <stdint.h>
#include <stdio.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>

#include "tftlcd.h"
#include "init.h"
#include "image.h"
#include "touch.h"

#include "SD_card.h"
#include "SD_FAT32.h"

//#include "sample1.h"						// ̹  8bit  200*120

void TFT_filenumber(void);			// display file number
void TFT_filename(U08 file_number);		// display BMP file name
void TFT_display_BMP(U32 sector);		// display BMP file of SD card

/* ---------------------------------------------------------------------------- */

volatile unsigned int timer = 0;		// 1 sec counter

unsigned char total_file;			// total file number
unsigned char file_number = 0;			// current file number
unsigned char BMP_type;				// BMP image type(P=portrait, L=landscape)

/* ---------------------------------------------------------------------------- */

ISR(TIMER1_COMPA_vect)				/* OC1A interrupt function */
{
  timer++;
}

void uartdisplay(void)
{

    printf("%s","****  signaltech ver 0.1  2009/10/14 **\n");
	printf("%s","*  TFT LCD Test Main UART0 38400bps   *\n");
	printf("%s","*  1  =>  red_set              \n");
	printf("%s","*  2  =>  Dot test             \n");
	printf("%s","*  3  =>  8 DEMO 		  	    \n");
	printf("%s","*  4  =>  16 DEMO      		\n");
	printf("%s","*  C,c =>  Clear  	 	    	\n");
	printf("%s","*  L,l =>  Dot test		    \n");
	printf("%s","*  R,r =>  Rectangle  		 	\n");
	printf("%s","***************************************\n");
	printf("test number or  character input :\n");

 }
 


void TFT_filenumber(void)			/* display file number */
{
  TFT_screen_mode(BMP_type);			// screen mode(Portrait or Landscape)

  TFT_xy(0,0);					// start position and color
  TFT_color(White, Transparent);

  TFT_English('(');
  TFT_unsigned_decimal(file_number+1,1,2);	// current file number
  TFT_English('/');
  TFT_unsigned_decimal(total_file,1,2);		// total file number
  TFT_English(')');
}

void TFT_filename(U08 file_number)		/* display BMP file name */
{
  unsigned char file_flag;

  file_flag = Get_long_filename(file_number);	// check file name

  if(file_flag == 0)				// short file name(8.3 format)
    TFT_short_filename(8,0,Yellow,Transparent);
  else if(file_flag == 1)			// long file name
    TFT_long_filename(8,0,Yellow,Transparent);
  else if(file_flag == 2)			// file name is longer than 195 characters
    TFT_string(8,0,White,Transparent,"* ϸ  ʰ *");
  else						// file name error
    TFT_string(8,0,White,Transparent,"*** ϸ  ***");
}

/* ---------------------------------------------------------------------------- */

struct BMP_header{				/* Header 14 bytes + InfoHeader 40 bytes */
 unsigned char signature[2];			// 'BM'
 unsigned long file_size;			// file size in bytes
 unsigned long reserved;			// unused (= 0)
 unsigned long data_offset;			// file offset to Raster Data

 unsigned long size;				// size of InfoHeader (= 40)
 unsigned long width;				// bitmap width
 unsigned long height;				// bitmap height
 unsigned int  planes;				// number of planes (= 1)
 unsigned int  bit_count;			// bits per pixel 
 unsigned long compression;			// type of compression   
 unsigned long image_size;			// size of image
 unsigned long x_pixels_per_m;			// horizontal resolution(pixels/meter)
 unsigned long y_pixels_per_m;			// vertical resolution(pixels/meter)
 unsigned long colors_used;			// number of actually used colors
 unsigned long colors_important;		// number of important colors. 0 = all
};

// Description : SD ī忡  BMP ̹  TFT-LCD ϱ
// sector = BMP ̹ ִ Ͻ ͹ȣ
//
//         [B]         [G]       [R]
//          5           6         5
//       11111000   11111100   11111000
//          &           &         &
//        buf[0]      buf[1]    buf[2]
//
//         >> 3        << 3      << 8 (BGR ¸ RGB · ٽ 迭)
//
//          [R]         [G]        [B]
// pixel = ?????      ??????      ????? = 16 bit

void TFT_display_BMP(U32 sector)		/* display BMP file of SD card */
{
  unsigned char buffer_control;
  unsigned int  i, pixel, sector_cnt;
  unsigned char BMPbuffer[512];   		// BMP data from SD card

  struct BMP_header *bmp_ptr;

  SD_read_sector(sector, BMPbuffer);		// read sector of BMP header

  bmp_ptr = (struct BMP_header *)BMPbuffer;

  if(bmp_ptr->width == 240)			// if 240*320, Portrait screen(bottom --> top)
    { BMP_type = 'P';
      lcd_data(0x16); lcd_data(0x0088);	// (MV=0, MX=0, MY=1, BGR=1)

lcd_cmd(0x0050);lcd_data(0x0000); // Horizontal GRAM Start Address
lcd_cmd(0x0051);lcd_data(0x00EF); // Horizontal GRAM End Address
lcd_cmd(0x0052);lcd_data(0x0000); // Vertical GRAM Start Address
lcd_cmd(0x0053);lcd_data(0x013F); // Vertical GRAM Start Address  
    

	lcd_cmd(0x0022);   //  RAM Data Write/Read  	  lcd_data(0x22);
    }
  else if(bmp_ptr->width == 320)		// if 320*240, Landscape screen(left --> right)
    { BMP_type = 'L';
      lcd_data(0x16); lcd_data(0x0028);	// (MV=1, MX=0, MY=0, BGR=1)
 
lcd_cmd(0x0050);lcd_data(0x0000); // Horizontal GRAM Start Address
lcd_cmd(0x0051);lcd_data(0x013F); // Horizontal GRAM End Address
lcd_cmd(0x0052);lcd_data(0x0000); // Vertical GRAM Start Address
lcd_cmd(0x0053);lcd_data(0x00EF); // Vertical GRAM Start Address
    
	  lcd_cmd(0x0022);   //  RAM Data Write/Read     lcd_data(0x22);
    }

  for(i = 0x36; i <= 509; i += 3)
    { pixel  = (BMPbuffer[i] & 0xf8) >> 3;	// Blue
      pixel |= (BMPbuffer[i+1] & 0xfc) << 3;	// Green
      pixel |= (BMPbuffer[i+2] & 0xf8) << 8;	// Red
      lcd_data(pixel);
    }
  sector++;
  buffer_control = 1;

  for(sector_cnt = 0; sector_cnt <= 449; sector_cnt++)	// read next sector and output RGB data
    {
      switch (buffer_control)			// rotate case 1, 2, 3
	{ case 1: pixel  = (BMPbuffer[510] & 0xF8) >> 3;
		  pixel |= (BMPbuffer[511] & 0xFC) << 3;
		  SD_read_sector(sector, BMPbuffer);
		  pixel |= (BMPbuffer[0] & 0xF8) << 8;
		  lcd_data(pixel);

		  for(i = 1; i <= 509; i += 3)
		    { pixel  = (BMPbuffer[i] & 0xf8) >> 3;
		      pixel |= (BMPbuffer[i+1] & 0xfc) << 3;
		      pixel |= (BMPbuffer[i+2] & 0xf8) << 8;
		      lcd_data(pixel);
		    }
		  sector++;
		  buffer_control = 2;
		  break;

	  case 2: pixel  = (BMPbuffer[511] & 0xF8) >> 3;
		  SD_read_sector(sector, BMPbuffer);
		  pixel |= (BMPbuffer[0] & 0xFC) << 3;
		  pixel |= (BMPbuffer[1] & 0xF8) << 8;
		  lcd_data(pixel);

		  for(i = 2; i <= 509; i += 3)
		    { pixel  = (BMPbuffer[i] & 0xF8) >> 3;
		      pixel |= (BMPbuffer[i+1] & 0xFC) << 3;
		      pixel |= (BMPbuffer[i+2] & 0xF8) << 8;
		      lcd_data(pixel);
		    }
		   sector++;
		   buffer_control = 3;
		   break;

	  case 3: SD_read_sector(sector, BMPbuffer);
		  if(sector_cnt != 449)
		    { for(i = 0; i <= 509; i += 3)
			{ pixel  = (BMPbuffer[i] & 0xF8) >> 3;
			  pixel |= (BMPbuffer[i+1] & 0xFC) << 3;
			  pixel |= (BMPbuffer[i+2] & 0xF8) << 8;
			  lcd_data(pixel);
			}
		    }
		  else				// if last sector, read 54 bytes only
		    { for(i = 0; i < 54; i += 3)
			{ pixel  = (BMPbuffer[i] & 0xF8) >> 3;
			  pixel |= (BMPbuffer[i+1] & 0xFC) << 3;
			  pixel |= (BMPbuffer[i+2] & 0xF8) << 8;
			  lcd_data(pixel);
			}
		    }
		  sector++;
		  buffer_control = 1;
		  break;
	}
    }

lcd_cmd(0x0050);lcd_data(0x0000); // Horizontal GRAM Start Address
lcd_cmd(0x0051);lcd_data(0x00EF); // Horizontal GRAM End Address
lcd_cmd(0x0052);lcd_data(0x0000); // Vertical GRAM Start Address
lcd_cmd(0x0053);lcd_data(0x013F); // Vertical GRAM Start Address  

}


int main(void)
{
 // unsigned char RXD;  

//unsigned char i;
 unsigned int i, x, y, color;
 
 
  unsigned char display_flag = 1;		// new screen display flag
  unsigned char filename_flag = 1;		// file name display flag

  unsigned long BMP_start_sector[MAX_FILE];	// BMP file start sector


  init();
  TSC2003_Setup();
  printf("%s","****  signaltech ver 0.1  2009/10/20 **\n");
	printf("%s","*  TFT LCD Test Main UART0 38400bps   *\n");
		
		stdout = &device1;   
  uartdisplay();
 TFT_SET();
 LCD_ON();
 lcd_cmd(0x0022);
  	LCD_Clear(); 

    	
//	Initialize_SD();				// initialize SD card
//  Initialize_FAT32();				// initialize FAT32 file system
	
	
		
Demo_display_8_color(); 
	delay_ms(500);
	delay_ms(500);
	delay_ms(500);
	delay_ms(500);
	LCD_Clear(); 	
	//Image_Disp_8bit(_SCREEN_COLUMN_SET,60,60,200,120,image_temp8_1);//  ̹  ǥ 32000Byte ̳(sample2_8.txt)
//	Image_Disp_8bit(ScreenSet,60,60,200,120,image_temp8_1);//  ̹  ǥ 32000Byte ̳(sample2_8.txt)

/*
  TCCR1A = 0x00;                                // CTC mode(4), don't output OC1A
  TCCR1B = 0x0C;                                // 16MHz/256/(1+62499) = 1Hz
  TCCR1C = 0x00;
  OCR1A = 62499;
  TCNT1 = 0x0000;

  TIMSK = 0x02;                                // enable OC1A interrupt
  TIFR = 0x2F;                                 // clear all interrupt flags
  sei();

  total_file = fatGetDirEntry(FirstDirCluster);	// get total file number

  for(i = 0; i < total_file; i++)		// get start address of all files
    BMP_start_sector[i] = fatClustToSect(file_start_cluster[i]);

  file_number = 0;
*/
	while(1)
	{ 


      TFT_string( 0,1,WHITE,   RED,"    test  ");
      TFT_string( 10,5,RED,    Transparent,"   Red ");
      TFT_string(15,10,GREEN,  Transparent,"  Gre ");
      TFT_string(19,15,BLUE,   Transparent,"  Blu ");
      TFT_string(20,20,YELLOW, Transparent,"  Yel ");     

      



	
	
	if(display_flag == 1)			// display BMP file, file number, and file name
        { Get_long_filename(file_number);	// check file name
	  if(extension != 0x00424D50)		// if not BMP file, skip
            { if(file_number < (total_file - 1))
	        file_number++;
	      else
	        file_number = 0;
	    }
          else					// if BMP file, display
	    { TFT_display_BMP(BMP_start_sector[file_number]);
              if(filename_flag == 1)
  	        { TFT_filenumber();
	          TFT_filename(file_number);
	        }
	      display_flag = 0;
              timer = 0;
	    }
	}

      if(timer >= 5)				// go next file by 5 sec step
	{ if(file_number < (total_file - 1))            
	    file_number++;
	  else
	    file_number = 0;
	  display_flag = 1;
        }
  
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	 // TFT_string(60,32,CYAN,   Transparent," û Cya ");
    //  TFT_string(80,32,MAGENTA,Transparent," ȫ Mag ");

//for(cut = 0; cut <= 6; cut++)		// Ӹ ̴ 
     
  
  /*    delay_ms(500);

      for(cut = 7; cut > 0; cut--)		// ٽ ǵ  
        { i = 0;
	  for(y = 0; y < 57; y++)
            for(x = 0; x < 32; x++)
              { color = pgm_read_word(&girl[cut-1][i++]);
                tftlcdSetPixel(x+104,y+150, color);
              }
          delay_ms(100);
        }
      delay_ms(2000);
   

	LCD_Clear(); 
*/



/*	
if(com1_rx_flg){					// COM1  ˻
	  		putchar(com1_rx_data);
		//	com1_rx_flg = 0;

//	RXD = RX0_char_scan();
    switch(com1_rx_data)
  {
	case '1':
		{
	//	Putchxy(100,100,'1');
	//	tftlcdImageWrite(90, 100, 60, 75, mainImage);
		delay_ms(500);
	//	tftlcdImageWrite(90, 100, 60, 75, mainImage);
		delay_ms(500);delay_ms(500);delay_ms(500);
	//	red_set(); 	
		printf(" 1"); }
		break;
	case '2':  
		{   LCD_gotoxy(120,125);  LCD_Dot(0xffe0);
		LCD_gotoxy(120,130); LCD_Dot(0xffff); 
        LCD_gotoxy(120,135);  LCD_Dot(0xffe0); 
	  	printf(" 2 ");
	    }
		break;
	case '3':
		{Demo_display_8_color();  	printf(" 3"); }
		break;
	case '4':
		{Demo_display_16_gray(); 		printf(" 4"); }
		break;
	case '5':
		{
		LCD_Clear(); 	
		tftlcdWriteChar(1,1,"B",0x001f);//1
		tftlcdPutStr(240,1,"ABDEFH",0x001f);
		printf(" 3"); }
		break;
	case '6':
		{
		//	tftlcdPutStr(7,3,"ABCDEFGHIJKLMNOPQRSTUVWXYZ",0xf800 );
		//tftlcdPutStr(5,5,"AA",0x07e0);
		tftlcdPutStr(25,5,"BBB",0x08e0);
		tftlcdPutStr(40,5,"iii",0x19e0);
		tftlcdPutStr(60,5,"QQQ",0x3ae0);
		tftlcdPutStr(80,5,"WWW",0x9be0);
		tftlcdPutStr(100,5,"RRR",0xace0);
		tftlcdPutStr(160,5,"YYY",0xbde0);

		tftlcdPutStr(200,5,"(**Y",0xf800);
		tftlcdPutStr(240,5,"(..)",0x001f);
		tftlcdPutStr(280,5,"Y^^Y",0xffff);

		tftlcdPutStr(350,5,"HHHH",0xdee0);
		tftlcdPutStr(390,5,"B",0xefe0);
		tftlcdPutStr(395,5,"7",0xf7e0);
		printf(" 3"); }
		break;

	case '7':
		{
	tftlcdPutStr(5,5,"ABC",0x10e0);
	tftlcdPutStr(5,15,"DEF",0x21e0);
	tftlcdPutStr(5,25,"GHI",0x32e0);
	tftlcdPutStr(5,40,"JKL",0x43e0);
	tftlcdPutStr(5,85,"MNO",0x54e0);
	tftlcdPutStr(5,100,"PQR",0x65e0);
	tftlcdPutStr(5,145,"STU",0x76e0);


	tftlcdPutStr(5,230,"$$$$$$$$$$$",0x80e0);


			
tftlcdPutStr(15,200,"@@@@@@@@@",0x97e0);



}
	break;


	case 'c':
	case 'C':
		{	LCD_Clear();   printf(" C");     }
	break;

	case 'l':
	case 'L':
	{	Line(0,0,399,239,GREEN);  	printf(" L");   }

     	break;


	case 'r':
	case 'R':
	{Rectangle(20,70,100,200,RED); 		printf(" R");  }
		break;

	case 't':
	case 'T':
		{Rectangle(20,70,100,200,RED); 		printf(" T");  }

	case '0':
		{ uartdisplay();		printf(" 0"); }
			break;


	default://  LCD_Clear();	
		{
	
		com1_rx_flg = 0;
	
		}
		
		}
		com1_rx_flg = 0;
	
	//{ 	delay_ms(500); 	deLCD_Clear();lay_ms(500);	delay_ms(500);	     LCD_Clear();
 	// 	}
	//red_set();
		//delay_ms(500);	delay_ms(500);
		//Demo_display_16_gray();
 		//delay_ms(500);	delay_ms(500);
  	
	
		
	
	  }  //switch
	if(Touch_Data(30)){					// ġ  ˻ 300ms
			printf("touch > (x)%d : (y)%d\r\n",Touch_X,Touch_Y);
						}
	
*/
	
	
	}  //while
}  //main
